/*  Copyright (C) 1996  Paul Daniel
    See the file "shotgun.c" for full copyright information.  */

/* fillwindows.c - routines to draw the directory tree and file list */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <vgagl.h>
#include "gui.h"
#include "getdirinfo.h"

void maketree(void *td, int nod, int dirtopy, int treehi) {

    int i, j, k, maxy=25, tx, ty;
    struct DDIR *directories;
    char dir[40];

    directories = (struct DDIR *)td;
    if (nod-dirtopy < maxy) {
        maxy = nod-dirtopy;
    }
    gl_fillbox(4, 40, 296, 400, background);
    for (i=0; i < nod; i++) {
        if ((i >= dirtopy) && (i < dirtopy+maxy)) {
            if (directories[i].level == 0) {
                drawfolder(0, 0, directories[0].filetype);
                tx = 2;
                ty = 0;
                transgrid(&tx, &ty, 2);
                if (i == treehi) {
                    gl_fillbox(tx, ty-1, 8, 10, lightcyan);
                }
                gl_write(tx, ty, directories[i].name); 
            }
            else {
                if (directories[i].level == directories[i+1].level &&
                 i < nod-1) {
                    drawtreeline((2*directories[i].level-1), i-dirtopy, 0);
                }
                else {
                    drawtreeline((2*directories[i].level-1), i-dirtopy, 1);
                }
                drawfolder((2*directories[i].level), i-dirtopy,
                 directories[i].filetype);
                tx = 2*directories[i].level+2;
                ty = i-dirtopy;
                transgrid(&tx, &ty, 2);
                strcpy(dir, (char *)(strrchr(directories[i].name, '/')+1));
                if (i == treehi) {
                    gl_fillbox(tx, ty-1, 8*strlen(dir), 10, lightcyan);
                }
                gl_write(tx, ty, dir);
            }
        }
        if ((directories[i].level < directories[i-1].level) && (i >0)) {
            j = i-1;
            while ((j > 0) && (directories[j].level > directories[i].level)) {
                if ((j >= dirtopy) && (j < dirtopy+maxy)) {
                    drawtreeline((2*directories[i].level-1), j-dirtopy, 2);
                }
                j--;
            }
            if ((j >= dirtopy) && (j < dirtopy+maxy)) {
                if (directories[j].level == directories[i].level) {
                    drawtreeline((2*directories[i].level-1), j-dirtopy, 0);
                }
                else {
                    drawtreeline((2*directories[i].level-1), j-dirtopy, 2);
                }
            }
        }
    }
}

void filestats(void *tf, int nof) {

    char tempstring[256];
    unsigned long total=0, tagtotal=0;
    struct GDIR *files;
    int not=0, i, number;

    files = (struct GDIR*)tf;
    for (i=0; i<nof; i++) {
        total += files[i].filesize;
        if (files[i].tag) {
            tagtotal += files[i].filesize;
            not++;
        }
    }
    number=nof;
    gl_fillbox(338, 26, 292, 8, lightgrey);
    if (not) {
        gl_write(338, 26, "Selected: ");
        total=tagtotal;
        number=not;
    }
    sprintf(tempstring, "%i", (total+512)/1024);
    gl_write(418, 26, tempstring);
    i = 8*strlen(tempstring);
    gl_write(418+i, 26, " Kbytes in ");
    sprintf(tempstring, "%i", number);
    gl_write(506+i, 26, tempstring);
    if (number == 1) {
        gl_write(506+i+strlen(tempstring)*8, 26, " file.");
    }
    else {
        gl_write(506+i+strlen(tempstring)*8, 26, " files.");
    }
}

void onefile(int i, void *tf, int filetopy, void *font, void *as, int nassn) {

    int j, total=0;
    char size[9], tempstring[23], color=16;
    struct GDIR *files;
    struct ASSN *associations;
    
    files = (struct GDIR *)tf;
    associations = (struct ASSN *)as;
    if (strchr(files[i+filetopy].name, '.') != NULL) {
        for (j=0; j<nassn; j++) {
            if (!strcmp((char *)strrchr(files[i+filetopy].name, '.')+1,
             associations[j].extension)) {
                if (files[i+filetopy].filetype == 3) {
                    color = cyan;
                }
                else {
                    color = associations[j].color;
                }
                files[i+filetopy].filetype = 6;
            }
        }
    }
    if (!strcmp(files[i+filetopy].name, "makefile") ||
     !strcmp(files[i+filetopy].name, "Makefile") ||
      !strcmp(files[i+filetopy].name, "Imakefile")) {
        files[i+filetopy].filetype = 6;
    }
    if (files[i+filetopy].filetype == 4) {
        color = green;
    }
    if (files[i+filetopy].filetype == 3) {
        color = cyan;
    }
    if (files[i+filetopy].tag) {
        gl_fillbox(336, 16*i+41, 286, 14, lightcyan);
    }
    drawfile(323, i, files[i+filetopy].filetype);
    gl_colorfont(8, 8, color, font);
    strncpy(tempstring, files[i+filetopy].name, 22);
    gl_write(336, 16*i+44, tempstring);
    gl_colorfont(8, 8, black, font);
    sprintf(size, "%li", files[i+filetopy].filesize);
    if (strlen(files[i+filetopy].name) < 22-strlen(size)) {
        gl_write(518-8*strlen(size), 16*i+44, size);
    }
    gl_write(526, 16*i+44, files[i+filetopy].timestamp);
}

void makelist(void *tf, int nof, int filetopy, void *font, void *as,
 int nassn) {

    int i, maxy=25;
    
    if (nof < maxy) {
        maxy = nof;
    }
    gl_fillbox(323, 40, 300, 400, background);
    for (i=0; i < maxy; i++) {
        onefile(i, tf, filetopy, font, as, nassn);
    }
    filestats(tf, nof);
}
