/*  Copyright (C) 1996  Paul Daniel
    See the file "shotgun.c" for full copyright information.  */

/* menu.c - define menus and handle menu operations */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <vgagl.h>
#include <vgamouse.h>
#include "gui.h"
#include "getdirinfo.h"

int getmenuwidth(int n, char *title, char *menu[], int *uw) {

    int max=0, i, underwidth;

    underwidth = *uw;
    for (i=0; i<n; i++) {
        if (strlen(menu[i]) > max) {
            max=strlen(menu[i]);
        }
    }
    if (strlen(title) > max) {
        underwidth=8*(strlen(title)+2);
    }
    else {
        underwidth=8*(max+2);
    }
    *uw = underwidth;
    return (max);
}

void drawmenu(int x, int y, char *title, int n, char *menu[], int max,
 int mode) {

    int i;

    drawbox(x, y-19, 8*strlen(title)+16, 18, 0);
    gl_write(x+8, y-14, title);
    drawbox(x, y, 8*(max+2), 16*(n+1), 0);
    for (i=0; i<n; i++) {
        if (menu[i] == "-") {
            gl_hline(x+8, y+16*i+15, x+8+max*8, darkgrey);
            gl_hline(x+8, y+16*i+16, x+8+max*8, white);
        }
        else {
            gl_write(x+8, y+16*i+12, menu[i]);
        }
    }
}

struct SPTR *domenu(void *td, int *d, void *tf, int *f, void *as, int *nas,
 int *th, int *dy, int *fy, int mx, int my, void *font, char *trashdir,
  int *df, struct CFG *config) {

    char *menu1t = "File";
    int menu1n=10;
    char *menu1[10] = { "Create Folder...",
                        "Delete Folder",
                        "-",
                        "Backup Selected Files",
                        "Select All Files",
                        "Deselect All Files",
                        "De/select Files By Type...",
                        "-",
                        "Add Association...",
                        "Delete Association..." };
                    
    char *menu2t = "Console";
    char *menu2[12] = {  "VC 1",
                        "VC 2",
                        "VC 3",
                        "VC 4",
                        "VC 5",
                        "VC 6",
                        "VC 7",
                        "VC 8",
                        "VC 9",
                        "VC 10",
                        "VC 11",
                        "VC 12" };
    
    char *menu3t = "Options";
    int menu3n=17;
    char *menu3[17] = { "Print Command...",
                        "View Command...",
                        "Edit Command...",
                        "Compress Command...",
                        "VT Switch Command...",
                        "-",
                        "Box 1 Title...",
                        "Box 2 Title...",
                        "Box 3 Title...",
                        "-",
                        "Printer Icon...",
                        "3 1/2 Drive Icon...",
                        "5 1/4 Drive Icon...",
                        "-",
                        "Backup Extension...",
                        "Number Of Consoles...",
                        "Floppy Drives..." };
                    
    char *colorlist[16] = { "Black",
                            "Blue",
                            "Green",
                            "Cyan",
                            "Red",
                            "Purple",
                            "Brown",
                            "Light Grey",
                            "Dark Grey",
                            "Light Blue",
                            "Light Green",
                            "Light Cyan",
                            "Light Red",
                            "Light Purple",
                            "Yellow",
                            "White" };

    char *runlist[3] = {    "Foreground",
                            "Background",
                            "Switch Console" };

    char *yn[2] = { "No",
                    "Yes" };
    
    char *ab[2] = { "a:",
                    "b:" };
    
    int x, y, width, vc, i, j, max, underwidth;
    int m, n, button, exitflag=0, deleteflag;
    int nod, nof, nassn, treehi, dirtopy, filetopy;
    char console[3], fname[64], arun[3], tempstring[64];
    char saveunder[16][16];
    char *undermenu, **menu, *title;
    struct DDIR *directories;
    struct GDIR *files;
    static struct SPTR *getback;
    static struct SPTR getbackstore;
    struct ASSN *associations;

    memset(fname, 0, 64);
    directories = (struct DDIR *)td;
    files = (struct GDIR *)tf;
    getback = &getbackstore;
    getback->dptr = directories;
    getback->fptr = files;
    associations = (struct ASSN *)as;
    nod = *d;
    nof = *f;
    nassn = *nas;
    treehi = *th;
    dirtopy = *dy;
    filetopy = *fy;
    deleteflag = *df;
    strcpy(fname, " ");
    m=whichmenu(mx);
    switch (m) {
    case 1 :    /* File menu */
        menu=menu1;
        title=menu1t;
        n=menu1n;
        x=0;
        y=40;
        break;
    case 2 :    /* Console menu */
        menu=menu2;
        title=menu2t;
        n=config->nc;
        x=48;
        y=40;
        break;
    case 3 :    /* Options menu */
        menu=menu3;
        title=menu3t;
        n=menu3n;
        x=120;
        y=40;
    }
    max = getmenuwidth(n, title, menu, &underwidth);
    width = 8*(max+2);
    undermenu = malloc(underwidth * (16*n+36));
    gl_getbox(x, y-20, underwidth, 16*n+36, undermenu);
    drawmenu(x, y, title, n, menu, max, 1);
    gl_getbox(mx, my, 16, 16, saveunder);
    gl_putboxmask(mx, my, 16, 16, pointerarrow);
    while (!exitflag) {
        kb_update();
        if(mouse_update()) {
            gl_putbox(mx, my, 16, 16, saveunder);
            mx = mouse_getx()*2;
            my = mouse_gety()*2;
            gl_getbox(mx, my, 16, 16, saveunder);
            gl_putboxmask(mx, my, 16, 16, pointerarrow);
        }
        button = mouse_getbutton();
        if (button & MOUSE_LEFTBUTTON) {
            if (whichmenu(mx) == m && getregion(mx, my) == 1) {
                swallow(MOUSE_LEFTBUTTON);
            }
            gl_putbox(mx, my, 16, 16, saveunder);
            gl_putbox(x, y-20, underwidth, 16*n+36, undermenu);
            free(undermenu);
            switch (m) {
            case 1 :    /* File menu */
                switch (inmenu(x, y, mx, my, width, n)) {
                case 1 :    /* create folder */
                    textquery("Create New Folder",
                     "Enter a name for the new folder:", fname, 20, font);
                    if (strcmp(fname, " ")) {
                        strcpy(tempstring, (char *)quoteit(fname));
                        if (!runcommand("mkdir", tempstring, NULL, trashdir,
                         font, 1)) {
                            if (directories[treehi].filetype == 2) {
                                directories[treehi].filetype = 1;
                            }
                            getback = (struct SPTR *)rescandir(directories,
                             &nod, files, &nof, &treehi, 1);
                            directories = getback->dptr;
                            files = getback->fptr;
                            maketree(directories, nod, dirtopy, treehi);
                            setwintop(308, 39, 401, 0, 25, dirtopy, nod, 0);
                        }
                    }
                    break;
                case 2 :    /* delete folder */
                    if (radiolist("Are You Sure?", yn, 2, font)) {
                        strcpy(tempstring,
                         (char *)quoteit(directories[treehi].name));
                        if (!runcommand("mv", tempstring, trashdir, trashdir,
                         font, 1)) {
                            getback = (struct SPTR *)rescandir(directories,
                             &nod, files, &nof, &treehi, 0);
                            directories = getback->dptr;
                            files = getback->fptr;
                            filetopy = 0;
                            maketree(directories, nod, dirtopy, treehi);
                            setwintop(308, 39, 401, 0, 25, dirtopy, nod, 0);
                            makelist(files, nof, filetopy, font,
                             associations, nassn);
                            setwintop(628, 39, 401, 0, 25, filetopy, nof, 0);
                            deleteflag = 1;
                        }
                    }
                    break;
                case 4 :    /* backup selected files */
                    for (i=0; i<nof; i++) {
                        if (files[i].tag) {
                            sprintf(tempstring, "%s.%s", files[i].name,
                             config->bak);
                            strcpy(fname, (char *)quoteit(tempstring));
                            strcpy(tempstring, (char *)quoteit(files[i].name));
                            runcommand("cp", tempstring, fname, trashdir,
                             font, 1);
                        }
                    }
                    getback = (struct SPTR *)getdirinfo(directories, &nod,
                     files, &nof, treehi, directories[treehi].name, 0);
                    directories = getback->dptr;
                    files = getback->fptr;
                    makelist(files, nof, filetopy, font, associations, nassn);
                    setwintop(628, 39, 401, 0, 25, filetopy, nof, 0);
                break;
                case 5 :    /* select all files */
                    for (i=0; i<nof; i++) {
                        files[i].tag = 1;
                    }
                    makelist(files, nof, filetopy, font, associations, nassn);
                    break;
                case 6 :    /* deselect all files */
                    for (i=0; i<nof; i++) {
                        files[i].tag = 0;
                    }
                    makelist(files, nof, filetopy, font, associations, nassn);
                    break;
                case 7 :    /* select by file type */
                    strcpy(tempstring, " ");
                    textquery("Extension",
                     "De/select files with which extension?", tempstring, 4,
                      font);
                    if (strcmp(tempstring, " ")) {
                        for (i=0; i<nof; i++) {
                            if (strchr(files[i].name, '.') != NULL) {
                                if (!strcmp((char *)strrchr(files[i].name,
                                 '.')+1, tempstring)) {
                                    files[i].tag = files[i].tag == 0 ? 1 : 0;
                                }
                            }
                        }
                        makelist(files, nof, filetopy, font, associations,
                         nassn);
                    }
                    break;
                case 9 :    /* add association */
                    strcpy(associations[nassn].extension, " ");
                    strcpy(associations[nassn].command, " ");
                    strcpy(arun, " ");
                    for (i=0; i<nof; i++) {
                        if (files[i].tag) {
                            if (files[i].filetype == 3 ||
                             files[i].filetype == 4) {
                                strcpy(associations[nassn].command,
                                 files[i].name);
                            }
                            else {
                                if (files[i].filetype != 6 &&
                                 strchr(files[i].name, '.') != NULL) {
                                    strcpy(associations[nassn].extension,
                                     strrchr(files[i].name, '.')+1);
                                }
                            }
                            break;
                        }
                    }
                    textquery("Extension",
                     "Enter the file extension to associate:",
                      associations[nassn].extension, 4, font);
                    textquery("Program",
                     "Associate that extension with which program?",
                      associations[nassn].command, 32, font);
                    associations[nassn].run = radiolist("Run Method", runlist,
                     3, font);
                    associations[nassn].color = radiolist("File List Color",
                     colorlist, 16, font);
                    if (!associations[nassn].color) {
                        associations[nassn].color = 16;
                    }
                    if (strcmp(associations[nassn].extension, " ") &&
                     strcmp(associations[nassn].command, " ")) {
                        nassn++;
                    }
                    makelist(files, nof, filetopy, font, associations, nassn);
                    break;
                case 10 :   /* delete association */
                    strcpy(fname, " ");
                    for (i=0; i<nof; i++) {
                        if (files[i].tag && files[i].filetype == 6) {
                            strcpy(fname, strrchr(files[i].name, '.')+1);
                        }
                    }
                    textquery("Delete Association",
                     "Enter the extension to delete:", fname, 4, font);
                    if (strcmp(fname, " ")) {
                        for (i=0; i<nassn; i++) {
                            if (!strcmp(associations[i].extension, fname)) {
                                for (j=i; j<nassn-1; j++) {
                                    strcpy(associations[j].extension,
                                     associations[j+1].extension);
                                    strcpy(associations[j].command,
                                     associations[j+1].command);
                                    associations[j].run = associations[j+1].run;
                                    associations[j].color =
                                     associations[j+1].color;
                                }
                                nassn--;
                                break;
                            }
                        }
                        getback = (struct SPTR *)getdirinfo(directories, &nod,
                         files, &nof, treehi, directories[treehi].name, 1);
                        directories = getback->dptr;
                        files = getback->fptr;
                        makelist(files, nof, filetopy, font, associations,
                         nassn);
                    }
                }
                break;
            case 2 :    /* Console menu */
                vc = inmenu(x, y, mx, my, width, n);
                if (vc) {
                    sprintf(console, "%i", vc);
                    runcommand(config->sc, console, "&", trashdir, font, 0);
                }
                break;
            case 3 :    /* Options menu */
                switch (inmenu(x, y, mx, my, width, n)) {
                case 1 :
                    textquery("Print Command",
                     "Command for drag and drop printing:", config->pc, 20,
                      font);
                    break;
                case 2 :
                    textquery("View Command", "Default text file viewer:",
                     config->vc, 20, font);
                    break;
                case 3 :
                    textquery("Edit Command", "Default editor:", config->ec,
                     20, font);
                    break;
                case 4 :
                    textquery("Compress Command",
                     "Command for drag and drop compression:", config->cc, 20,
                      font);
                    break;
                case 5 :
                    textquery("VT Switch Command",
                     "Default console switching command:", config->sc, 20,
                      font);
                    break;
                case 7 :
                    textquery("Box 1 Title", "Title of program box one:",
                     config->t1, 10, font);
                    drawbox(7, 480-37, 86, 14, 0);
                    gl_write(50-4*strlen(config->t1), 480-34, config->t1);
                    break;
                case 8 :
                    textquery("Box 2 Title", "Title of program box two:",
                     config->t2, 10, font);
                    drawbox(97, 480-37, 86, 14, 0);
                    gl_write(140-4*strlen(config->t2), 480-34, config->t2);
                    break;
                case 9 :
                    textquery("Box 3 Title", "Title of program box three:",
                     config->t3, 10, font);
                    drawbox(187, 480-37, 86, 14, 0);
                    gl_write(230-4*strlen(config->t3), 480-34, config->t3);
                    break;
                case 11 :
                    textquery("Printer Icon",
                     "Command to run when this icon is pressed:", config->pic,
                      20, font);
                    break;
                case 12 :
                    textquery("3 1/2 Drive Icon",
                     "Command to run when this icon is pressed:", config->tic,
                      20, font);
                    break;
                case 13 :
                    textquery("5 1/4 Drive Icon",
                     "Command to run when this icon is pressed:", config->fic,
                      20, font);
                    break;
                case 15 :
                    textquery("Backup Extension",
                     "Default extension for file backups:", config->bak, 10,
                      font);
                    break;
                case 16 :
                    sprintf(tempstring, "%i", config->nc);
                    textquery("Number of Consoles",
                     "Number of consoles in the Console menu:", tempstring, 3,
                      font);
                    config->nc = atoi(tempstring);
                    if (config->nc > 12) {
                        config->nc = 12;
                    }
                    break;
                case 17 :
                    i = radiolist("3 1/2 Drive Is...", ab, 2, font);
                    if (i == 0) {
                        strcpy(config->tl, "a:");
                    }
                    else {
                        strcpy(config->tl, "b:");
                    }
                    i = radiolist("5 1/4 Drive Is...", ab, 2, font);
                    if (i == 0) {
                        strcpy(config->fl, "a:");
                    }
                    else {
                        strcpy(config->fl, "b:");
                    }
                }
            }
            exitflag = 1;
        }
    }
    *d = nod;
    *f = nof;
    *nas = nassn;
    *th = treehi;
    *dy = dirtopy;
    *fy = filetopy;
    *df = deleteflag;
    return (getback);
}
