/*  Copyright (C) 1996  Paul Daniel
    See the file "shotgun.c" for full copyright information.  */

/* mousepos - routines to determine mouse position at button press */

#include <string.h>
#include "getdirinfo.h"

#define IWIDTH 400
#define IHEIGHT 130

int getregion(int mx, int my) {

    int region=0;
    
    if (mx>0 && mx<=192 && my>20 && my<39) {
        region=1;   /* menubar */
    }
    if (mx>0 && mx<300 && my>40 && my<439) {
        region=2;   /* tree window */
    }
    if (mx>304 && mx<319 && my>40 && my<439) {
        region=3;   /* tree scrollbar */
    }
    if (mx>320 && mx<623 && my>40 && my<439) {
        region=4;   /* file window */
    }
    if (mx>624 && mx<639 && my>40 && my<439) {
        region=5;   /* file scrollbar */
    }
    if (mx>5 && mx<270 && my>442 && my<457) {
        region=6;   /* program boxes */
    }
    if (mx>320 && mx<620 && my>440 && my<459) {
        region=7;   /* icons */
    }
    if (mx>5 && mx<635 && my>460 && my<479) {
        region=8;   /* launcher buttons */
    }
    if (mx>4 && mx<15 && my>4 && my <15) {
        region=9;   /* close button */
    }
    return (region);
}

int mousetree(int mx, int y, void *td, int nod, int dirtopy) {

    int x, action=0;
    struct DDIR *directories;
    char dir[40];

    x=(mx-4)/8;
    directories = (struct DDIR *)td;
    if (y+dirtopy < nod) {
        if (y+dirtopy) {
            strcpy(dir, (char *)(strrchr(directories[y+dirtopy].name, '/')+1));
        }
        else {
            strcpy(dir, "/");
        }
        if ((x==2*directories[y+dirtopy].level) ||
         (x==2*directories[y+dirtopy].level+1)) {
            action=1;
        }
        if ((x>directories[y+dirtopy].level*2+1) &&
         (x<directories[y+dirtopy].level*2+2+strlen(dir))) {
            action=2;
        }
    }
    return (action);
}

int scrollwindow(int y, int l, int my, int sbl, int sby) {

    int action=0;

    if ((my >= y) && (my < y+11)) {
        action = 1;
    }
    if ((my >= y+11) && (my < sby)) {
        action = 2;
    }
    if ((my >= sby) && (my < sby+sbl)) {
        action = 3;
    }
    if ((my >= sby+sbl) && (my < y+l-11)) {
        action = 4;
    }
    if ((my >= y+l-11) && (my < y+l)) {
        action = 5;
    }
    return (action);
}

int iconselect(int mx) {

    int button=0;

    if (mx>325 && mx<352) {
        button=1;
    }
    if (mx>363 && mx<390) {
        button=2;
    }
    if (mx>401 && mx<428) {
        button=3;
    }
    if (mx>439 && mx<466) {
        button=4;
    }
    if (mx>477 && mx<504) {
        button=5;
    }
    if (mx>515 && mx<542) {
        button=6;
    }
    if (mx>553 && mx<580) {
        button=7;
    }
    if (mx>591 && mx<618) {
        button=8;
    }
    return (button);
}

int whichbox(int mx) {

    int button=0;

    if (mx>7 && mx<92) {
        button=1;
    }
    if (mx>97 && mx<182) {
        button=2;
    }
    if (mx>187 && mx<275) {
        button=3;
    }
    return (button);
}

int inbox(int x, int y, int height, int width, int mx, int my) {

    int action=0;

    if (mx>x+3 && mx<x+14 && my>y+3 && my<y+14) {
        action=1;
    }
    if (mx>x+5 && mx<x+width-20 && my>y+18 && my<y+height-6) {
        action=2;
    }
    if (mx>x+width-12 && mx<x+width-3 && my>y+16 && my<y+height-3) {
        action=3;
    }
    if (mx>x+width || mx<x || my>y+height || my<y) {
        action=4;
    }
    return (action);
}

int ininfo(int x, int y, int mx, int my) {

    int action=0;

    if (mx>x+3 && mx<x+14 && my>y+3 && my<y+14) {
        action=1;
    }
    if (mx>x+6 && mx<x+14 && my>y+26 && my<y+34) {
        action=2;
    }
    if (mx>x+6 && mx<x+14 && my>y+74 && my<y+82) {
        action=3;
    }
    if (mx>x+206 && mx<x+214 && my>y+74 && my<y+82) {
        action=4;
    }
    if (mx>x+118 && mx<x+238 && my>y+114 && my<y+122) {
        action=5;
    }
    return (action);
}

int inperms(int x, int mx) {

    int bit=0;

    if (mx>x+118 && mx<x+125) {
        bit=256;
    }
    if (mx>x+126 && mx<x+133) {
        bit=128;
    }
    if (mx>x+134 && mx<x+141) {
        bit=64;
    }
    if (mx>x+166 && mx<x+173) {
        bit=32;
    }
    if (mx>x+174 && mx<x+181) {
        bit=16;
    }
    if (mx>x+182 && mx<x+189) {
        bit=8;
    }
    if (mx>x+214 && mx<x+221) {
        bit=4;
    }
    if (mx>x+222 && mx<x+229) {
        bit=2;
    }
    if (mx>x+230 && mx<x+237) {
        bit=1;
    }
    return (bit);
}

int whichlaunch(int mx) {

    int action=0;

    if (mx>7 && mx<93) {
        action=1;
    }
    if (mx>97 && mx<183) {
        action=2;
    }
    if (mx>187 && mx<273) {
        action=3;
    }
    if (mx>277 && mx<363) {
        action=4;
    }
    if (mx>367 && mx<453) {
        action=5;
    }
    if (mx>457 && mx<543) {
        action=6;
    }
    if (mx>547 && mx<633) {
        action=7;
    }
    return (action);
}

int whichmenu(int mx) {

    int menu;

    if (mx>0 && mx<=48) {
        menu=1;
    }
    if (mx>48 && mx<=120) {
        menu=2;
    }
    if (mx>120 && mx<=192) {
        menu=3;
    }
    return (menu);
}

int inmenu(int x, int y, int mx, int my, int width, int n) {

    int item=0;

    if (mx>x && mx<x+width && my>y+8 && my<y+8+16*n) {
        item=(my-(y+8))/16+1;
    }
    return (item);
}
