/*  Shotgun Shell - a graphical, mouse-based file manager/program launcher
                    for Linux
    Copyright (C) 1996  Paul Daniel

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/* Shotgun Shell v0.1 -- Sept. 16, 1995
                 v0.4 -- Oct.  23, 1995
                 v0.8 -- Nov.   8, 1995
                 v0.9 -- Dec.  27, 1995
                 v1.0 -- Jan.  12, 1996
                 v1.1 -- Feb.   8, 1996 */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>
#include <errno.h>
#include <vga.h>
#include <vgagl.h>
#include <vgamouse.h>
#include "kb.h"
#include "gui.h"
#include "getdirinfo.h"

#define vgamode G640x480x256

int main(int argc, char *argv[]) {

    int i=0, j=0, x, y, y2, dmy;
    int mx=200, my=200, button, dirtopy=0, filetopy=0, treehi=0;
    int flag=0, k, exitflag=0, deleteflag=0;
    int nassn=0, napps=0, ngames=0, nutils=0, nof=0, nod=1;
    unsigned int delay;
    char datestring[26], checkdate[26];
    char saveunder[16][16];
    char tempstring[256], source[256], dest[256], *home, *cmnd, command[30];
    char trashdir[64];
    struct CFG config;
    struct ASSN associations[30];
    struct DDIR *directories;
    struct GDIR *files;
    struct SPTR *getback;
    struct PROG apps[30], games[30], utils[30], hotlist[7];
    struct tm *tm;
    time_t when;
    FILE *t;
    void *font;
    
/* Load config, initialize program, and draw static portions of the screen */

    strcpy(config.pc, "lpr");
    strcpy(config.vc, "less");
    strcpy(config.ec, "vi");
    strcpy(config.cc, "gzip");
    strcpy(config.sc, "chvt");
    strcpy(config.t1, "Apps");
    strcpy(config.t2, "Games");
    strcpy(config.t3, "Utilities");
    strcpy(config.tl, "a:");
    strcpy(config.fl, "b:");
    strcpy(config.pic, "lpq");
    strcpy(config.tic, "mdir a:");
    strcpy(config.fic, "mdir b:");
    strcpy(config.bak, "bak");
    config.nc = 8;
    readconfig(associations, &nassn, apps, &napps, games, &ngames, utils,
     &nutils, &config);
    directories = (struct DDIR *)malloc(sizeof(struct DDIR));
    files = (struct GDIR *)malloc(sizeof(struct GDIR));
    getback = (struct SPTR *)malloc(sizeof(struct SPTR));

    strcpy(directories[0].name, "/");
    directories[0].filetype = 7;
    directories[0].level = 0;
    getback = (struct SPTR *)getdirinfo(directories, &nod, files, &nof, 0,
     directories[0].name, 1);
    directories = getback->dptr;
    files = getback->fptr;

    vga_disabledriverreport();
    vga_init();
    vga_setmousesupport(1);
    vga_setmode(vgamode);
    gl_setcontextvga(vgamode);
    gl_enableclipping();
    gl_clearscreen(background);
    font = initfont();
    kb_install(KB_FLAG_EMERGENCY_EXIT);
    delay = calibrate();

    drawscreen(font, config.t1, config.t2, config.t3);
    makehotlist(hotlist, apps, napps, games, ngames, utils, nutils, font);

    home=getenv("HOME");
    sprintf(trashdir, "%s/.trash", home);
    t = fopen(trashdir, "r");
    fclose(t);
    if (errno == 22) {
        runcommand("mkdir", trashdir, NULL, trashdir, font, 0);
    }
    tempstring[0]='/';
    for (i=1; i<=strlen(home); i++) {
        if (home[i] == '/' || i==strlen(home)) {
            while (strcmp(directories[treehi].name, tempstring) != 0) {
                treehi++;
            }
            getback = (struct SPTR *)getdirinfo(directories, &nod, files,
             &nof, treehi, directories[treehi].name, 1);
            directories = getback->dptr;
            files = getback->fptr;
        }
        tempstring[i] = home[i];
    }

    maketree(directories, nod, dirtopy, treehi);
    makelist(files, nof, filetopy, font, associations, nassn);
    setwintop(308, 39, 401, 0, 25, dirtopy, nod, 0);
    setwintop(628, 39, 401, 0, 25, filetopy, nof, 0);

    mouse_setposition(mx/2, my/2);
    gl_getbox(mx, my, 16, 16, saveunder);

/* Main loop */

    while (!exitflag) {
        time(&when);
        tm = localtime(&when);
        strftime(datestring, 23, "%a %b %d %Y %I:%M", tm);
        if (tm->tm_hour >= 12) {
            strcat(datestring, "PM");
        }
        else {
            strcat(datestring, "AM");
        }
        if (strcmp(checkdate, datestring)) {
            strcpy(checkdate, datestring);
            gl_colorfont(8, 8, white, font);
            gl_fillbox(450, 6, 184, 8, blue);
            gl_write(450, 6, datestring);
            gl_colorfont(8, 8, black, font);
        }
        if(mouse_update()) {
            gl_putbox(mx, my, 16, 16, saveunder);
            flag = 0;
            mx = mouse_getx()*2;
            if (mx > 639) {
                mx = 639;
                flag = 1;
            }
            my = mouse_gety()*2;
            if (my > 479) {
                my = 479;
                flag = 1;
            }
            if (flag) {
                mouse_setposition(mx/2, my/2);
                flag = 0;
            }
            gl_getbox(mx, my, 16, 16, saveunder);
            if (dmy) {
                gl_putboxmask(mx, my, 15, 14, foldericon);
            }
            else {
                gl_putboxmask(mx, my, 16, 16, pointerarrow);
            }
        }
        button = mouse_getbutton();
        if (button & MOUSE_RIGHTBUTTON) {
            switch (getregion(mx, my)) {
            case 2 :    /* right click in tree window (directory link/move/copy) */
                y = (my-40)/16;
                if (mousetree(mx, y, directories, nod, dirtopy)) {
                    if (dmy) {
                        treehi = y+dirtopy;
                        gl_putbox(mx, my, 16, 16, saveunder);
                        strcpy(source, (char *)quoteit(directories[dmy].name));
                        strcpy(dest, (char *)quoteit(directories[treehi].name));
                        if (kb_key(54)) {
                            flag = runcommand("ln -s", source, dest, trashdir,
                             font, 1);
                        }
                        else {
                            if (kb_key(KB_SCAN_RCONTROL)) {
                                flag = runcommand("cp -r", source, dest, trashdir,
                                 font, 1);
                            }
                            else {
                                flag = runcommand("mv", source, dest, trashdir,
                                 font, 1);
                            }
                        }
                        if (!flag) {
                            strcpy(tempstring, directories[treehi].name);
                            getback = (struct SPTR *)rescandir(directories, &nod,
                             files, &nof, &dmy, 0);
                            directories = getback->dptr;
                            files = getback->fptr;
                            i = 0;
                            while (strcmp(tempstring, directories[i].name) &&
                             (i < nod)) {
                                i++;
                            }
                            if (i < nod) {
                                treehi = i;
                                getback = (struct SPTR *)rescandir(directories,
                                 &nod, files, &nof, &treehi, 1);
                                directories = getback->dptr;
                                files = getback->fptr;
                            }
                            setwintop(308, 39, 401, 0, 25, dirtopy, nod, 0);
                            setwintop(628, 39, 401, 0, 25, filetopy, nof, 0);
                            maketree(directories, nod, dirtopy, treehi);
                            makelist(files, nof, filetopy, font, associations,
                             nassn);
                        }
                        else {
                            treehi = dmy;
                        }
                        mx = mouse_getx()*2;
                        my = mouse_gety()*2;
                        gl_getbox(mx, my, 16, 16, saveunder);
                        gl_putboxmask(mx, my, 16, 16, pointerarrow);
                        dmy = 0;
                    }
                    else {
                        gl_putbox(mx, my, 16, 16, saveunder);
                        gl_putboxmask(mx, my, 15, 14, foldericon);
                        swallow(MOUSE_RIGHTBUTTON);
                        dmy = y+dirtopy;
                    }
                }
                else {
                    dmy = 0;
                }
                break;
            case 3 :        /* right mouse click in tree scrollbar */
                if (dmy) {
                    gl_putbox(mx, my, 16, 16, saveunder);
                    dirtopy=setwintop(308, 39, 401, my, 25, dirtopy, nod,
                     MOUSE_RIGHTBUTTON);
                    maketree(directories, nod, dirtopy, treehi);
                    mx = mouse_getx()*2;
                    my = mouse_gety()*2;
                    gl_getbox(mx, my, 16, 16, saveunder);
                    gl_putboxmask(mx, my, 15, 14, foldericon);
                }
                break;
            case 4 :    /* right click and drag in file window */
                y=(my-40)/16;
                if (y < nof && !dmy) {
                    x=0;
                    y2 = -1;
                    if (files[y+filetopy].tag == 0) {
                        y2=y+filetopy;
                    }
                    else {
                        for (i=0; i<nof; i++) {
                            if (files[i].tag) {
                                x++;
                            }
                        }
                    }
                    gl_putbox(mx, my, 16, 16, saveunder);
                    if (x > 1) {
                        putfiles(mx, my);
                    }
                    else {
                        gl_putboxmask(mx, my, 11, 14, fileicon);
                    }
                    while (button & MOUSE_RIGHTBUTTON) {
                        if (mouse_update()) {
                            gl_putbox(mx, my, 16, 16, saveunder);
                            mx = mouse_getx()*2;
                            my = mouse_gety()*2;
                            gl_getbox(mx, my, 16, 16, saveunder);
                            if (x > 1) {
                                putfiles(mx, my);
                            }
                            else {
                                gl_putboxmask(mx, my, 11, 14, fileicon);
                            }
                        }
                        button = mouse_getbutton();
                    }
                    y=(my-40)/16;
                    gl_putbox(mx, my, 16, 16, saveunder);
                    switch (getregion(mx, my)) {
                    case 2 :    /* drop in tree window */
                        if(mousetree(mx, y, directories, nod, dirtopy)) {
                            for (i=0; i<nof; i++) {
                                if ((files[i].tag && y2<0) || i == y2) {
                                    strcpy(dest, (char *)quoteit(directories[y+dirtopy].name));
                                    if (kb_key(54)) {
                                        sprintf(tempstring, "%s/%s",
                                         directories[treehi].name,
                                          files[i].name);
                                        strcpy(source,
                                         (char *)quoteit(tempstring));
                                        flag = runcommand("ln -s", source,
                                         dest, trashdir, font, 1);
                                    }
                                    else {
                                        strcpy(source,
                                         (char *)quoteit(files[i].name));
                                        if (kb_key(KB_SCAN_RCONTROL)) {
                                            flag = runcommand("cp", source,
                                             dest, trashdir, font, 1);
                                        }
                                        else {
                                            flag = runcommand("mv", source,
                                             dest, trashdir, font, 1);
                                        }
                                    }
                                }
                            }
                            if (!flag) {
                                getback = (struct SPTR *)getdirinfo(directories,
                                 &nod, files, &nof, treehi,
                                  directories[treehi].name, 0);
                                directories = getback->dptr;
                                files = getback->fptr;
                                if (filetopy + 25 > nof) {
                                    filetopy = nof - 25;
                                }
                                if (filetopy < 0) {
                                    filetopy = 0;
                                }
                                setwintop(628, 39, 401, 0, 25, filetopy, nof, 0);
                                makelist(files, nof, filetopy, font, associations,
                                 nassn);
                            }
                        }       
                        break;
                    case 6 :    /* drop on program buttons */
                        for (i=0; i<nof; i++) {
                            if (((files[i].tag && y2<0) || i == y2) &&
                             (files[i].filetype == 4 ||
                              files[i].filetype == 3)) {
                                memset(source, 0, 255);
                                strcpy(source, " ");
                                textquery(files[i].name,
                                 "Enter any optional parameters:", source, 16,
                                  font);
                                strcpy(tempstring, files[i].name);
                                if (strcmp(source, " ")) {
                                    strcat(tempstring, " ");
                                    strcat(tempstring, source);
                                }
                                switch (whichbox(mx)) {
                                case 1 :
                                    napps = insprog(apps, napps, tempstring);
                                    break;
                                case 2 :
                                    ngames = insprog(games, ngames, tempstring);
                                    break;
                                case 3 :
                                    nutils = insprog(utils, nutils, tempstring);
                                }
                            }
                        }
                        break;
                    case 7 :    /* drop on icons */
                        flag=1;
                        k=0;
                        switch (iconselect(mx)) {
                        case 0 :
                            flag=0;
                            break;
                        case 1 :    /* printer icon */
                            strcpy(command, config.pc);
                            strcpy(dest, "");
                            break;
                        case 2 :    /* 3 1/2 drive icon */
                            k=0;
                            strcpy(command, "mcopy -n");
                            strcpy(dest, config.tl);
                            if (kb_key(KB_SCAN_RALT)) {
                                k=1;
                            }
                            break;
                        case 3 :    /* 5 1/4 drive icon */
                            k=0;
                            strcpy(command, "mcopy -n");
                            strcpy(dest, config.fl);
                            if (kb_key(KB_SCAN_RALT)) {
                                k=1;
                            }
                            break;
                        case 4 :    /* viewer icon */
                            flag=2;
                            sprintf(command, "open -sw %s", config.vc);
                            strcpy(dest, "&");
                            break;
                        case 5 :    /* editor icon */
                            flag=2;
                            sprintf(command, "open -sw %s", config.ec);
                            strcpy(dest, "&");
                            break;
                        case 6 :    /* compress icon */
                            strcpy(command, config.cc);
                            strcpy(dest, "");
                            break;
                        case 7 :    /* man icon */
                            flag=3;
                            strcpy(command, "open -sw man");
                            strcpy(dest, "&");
                            break;
                        case 8 :    /* trash icon */
                            strcpy(command, "mv");
                            strcpy(dest, trashdir);
                            deleteflag=1;
                        }
                        if (flag) {
                            for (i=0; i<nof; i++) {
                                if ((files[i].tag && y2<0) || i == y2) {
                                    strcpy(source,
                                     (char *)quoteit(files[i].name));
                                    if (flag==3) {
                                        strcpy(source, files[i].name);
                                        strtok(source, ".");
                                    }
                                    if (vga_getmousetype() == 4 && flag > 1) {
                                        mouse_close();
                                    }
                                    j = runcommand(command, source, dest,
                                     trashdir, font, 1);
                                    if (vga_getmousetype() == 4 && flag > 1) {
                                        vga_setmousesupport(1);
                                    }
                                    if (flag < 2) {
                                        files[i].tag=0;
                                    }
                                    if (k == 1) {
                                        strcpy(source,
                                         (char *)quoteit(files[i].name)); 
                                        j = runcommand("rm", source, NULL,
                                         trashdir, font, 1);
                                    }
                                }
                            }
                        }
                        if (flag == 1 && !j) {
                            getback = (struct SPTR *)getdirinfo(directories,
                             &nod, files, &nof, treehi,
                              directories[treehi].name, 0);
                            directories = getback->dptr;
                            files = getback->fptr;
                            if (filetopy + 25 > nof) {
                                filetopy = nof - 25;
                            }
                            if (filetopy < 0) {
                                filetopy = 0;
                            }
                            setwintop(628, 39, 401, 0, 25, filetopy, nof, 0);
                            makelist(files, nof, filetopy, font, associations,
                             nassn);
                            break;
                        }
                    }
                    mx = mouse_getx()*2;
                    my = mouse_gety()*2;
                    gl_getbox(mx, my, 16, 16, saveunder);
                    gl_putboxmask(mx, my, 16, 16, pointerarrow);
                }
                break;
            case 7 :    /* right mouse click on trash icon (directory delete) */
                if (iconselect(mx) == 8 && dmy) {
                    gl_putbox(mx, my, 16, 16, saveunder);
                    strcpy(tempstring, (char *)quoteit(directories[dmy].name));
                    if (!runcommand("mv", tempstring, trashdir, trashdir,
                     font, 1)) {
                        getback = (struct SPTR *)rescandir(directories, &nod,
                         files, &nof, &dmy, 0);
                        treehi = dmy;
                        filetopy = 0;
                        directories = getback->dptr;
                        files = getback->fptr;
                        maketree(directories, nod, dirtopy, treehi);
                        setwintop(308, 39, 401, 0, 25, dirtopy, nod, 0);
                        makelist(files, nof, filetopy, font, associations,
                         nassn);
                        setwintop(628, 39, 401, 0, 25, filetopy, nof, 0);
                    }
                    mx = mouse_getx()*2;
                    my = mouse_gety()*2;
                    gl_getbox(mx, my, 16, 16, saveunder);
                    gl_putboxmask(mx, my, 16, 16, pointerarrow);
                    deleteflag = 1;
                }
            default :
                dmy = 0;
            }
        }
        if (button & MOUSE_MIDDLEBUTTON  || ((button & MOUSE_LEFTBUTTON) &&
         kb_key(KB_SCAN_I))) {
            flag=0;
            y=(my-40)/16;
            gl_putbox(mx, my, 16, 16, saveunder);
            switch (getregion(mx, my)) {
            case 2 :
                if (y+dirtopy < nod && mousetree(mx, y, directories, nod,
                 dirtopy)) {
                    flag=fileinfo(mx, my, 0, directories[y+dirtopy].name,
                     trashdir, font);
                }
                if (flag) {
                    maketree(directories, nod, dirtopy, treehi);
                }
                break;
            case 4 :
                if (y < nof) {
                    flag=fileinfo(mx, my, 1, files[y+filetopy].name, trashdir,
                     font);
                }
                if (flag) {
                    getback = (struct SPTR *)getdirinfo(directories, &nod,
                     files, &nof, treehi, directories[treehi].name, 0);
                    directories = getback->dptr;
                    files = getback->fptr;
                    makelist(files, nof, filetopy, font, associations, nassn);
                }
            }
            mx = mouse_getx()*2;
            my = mouse_gety()*2;
            gl_getbox(mx, my, 16, 16, saveunder);
            gl_putboxmask(mx, my, 16, 16, pointerarrow);
        }
        if ((button & MOUSE_LEFTBUTTON) && !dmy) {
            gl_putbox(mx, my, 16, 16, saveunder);
            switch (getregion(mx, my)) {
            case 1 :        /* left mouse click on menu bar */
                swallow(MOUSE_LEFTBUTTON);
                getback = (struct SPTR *)domenu(directories, &nod, files,
                 &nof, associations, &nassn, &treehi, &dirtopy, &filetopy, mx,
                  my, font, trashdir, &deleteflag, &config);
                directories = getback->dptr;
                files = getback->fptr;
                break;
            case 2 :        /* left mouse click in tree window */
                flag=1;
                y=(my-40)/16;
                switch (mousetree(mx, y, directories, nod, dirtopy)) {
                case 0 :
                    flag=0;
                    break;
                case 1 :    /* click on folder icon */
                    filetopy = 0;
                    treehi=y+dirtopy;
                    switch(directories[treehi].filetype) {
                    case 0 :    /* open link dir */
                        getback = (struct SPTR *)getdirinfo(directories, &nod,
                         files, &nof, treehi, directories[treehi].name, 1);
                        directories = getback->dptr;
                        files = getback->fptr;
                        break;
                    case 1 :    /* open dir with subs */
                        getback = (struct SPTR *)getdirinfo(directories, &nod,
                         files, &nof, treehi, directories[treehi].name, 1);
                        directories = getback->dptr;
                        files = getback->fptr;
                        break;
                    case 2 :    /* rescan plain dir */
                        getback = (struct SPTR *)getdirinfo(directories, &nod,
                         files, &nof, treehi, directories[treehi].name, 0);
                        directories = getback->dptr;
                        files = getback->fptr;
                        break;
                    case 7 :    /* close dir with subs */
                        getback = (struct SPTR *)collapsedir(directories,
                         &nod, treehi);
                        directories = getback->dptr;
                        getback = (struct SPTR *)getdirinfo(directories, &nod,
                         files, &nof, treehi, directories[treehi].name, 0);
                        directories = getback->dptr;
                        files = getback->fptr;
                        break;
                    case 8 :    /* close link dir */
                        getback = (struct SPTR *)collapsedir(directories,
                         &nod, treehi);
                        directories = getback->dptr;
                        getback = (struct SPTR *)getdirinfo(directories, &nod,
                         files, &nof, treehi, directories[treehi].name, 0);
                        directories = getback->dptr;
                        files = getback->fptr;
                    }
                    break;
                case 2 :    /* click on directory name */
                    filetopy = 0;
                    treehi=y+dirtopy;
                    getback = (struct SPTR *)getdirinfo(directories, &nod,
                     files, &nof, treehi, directories[treehi].name, 0);
                    directories = getback->dptr;
                    files = getback->fptr;
                }
                if (flag) {
                    setwintop(308, 39, 401, 0, 25, dirtopy, nod, 0);
                    setwintop(628, 39, 401, 0, 25, filetopy, nof, 0);
                    maketree(directories, nod, dirtopy, treehi);
                    makelist(files, nof, filetopy, font, associations, nassn);
                }
                break;
            case 3 :        /* left mouse click in tree scrollbar */
                dirtopy=setwintop(308, 39, 401, my, 25, dirtopy, nod,
                 MOUSE_LEFTBUTTON);
                maketree(directories, nod, dirtopy, treehi);
                break;
            case 4 :        /* left mouse click in file window (tagging and launching) */
                y=(my-40)/16;
                switch (checkclick(MOUSE_LEFTBUTTON, delay/5)) {
                case 1 :    /* single click - tagging */
                    if (y < nof) {
                        if (kb_key(KB_SCAN_RCONTROL)) {
                            files[filetopy+y].tag = !files[filetopy+y].tag;
                            gl_fillbox(336, 16*y+41, 286, 14, background);
                            onefile(y, files, filetopy, font, associations,
                             nassn);
                            filestats(files, nof);
                        }
                        if (kb_key(54)) {
                            i=0;
                            files[filetopy+y].tag = 2;
                            while (files[i].tag != 1 && i < nof) {
                                i++;
                            }
                            if (i < nof) {
                                if (i < filetopy+y) {
                                    flag = -1;
                                }
                                else {
                                    flag = 1;
                                }
                                for (x=filetopy+y; x!=i; x+=flag) {
                                    files[x].tag = 1;
                                }
                                makelist(files, nof, filetopy, font,
                                 associations, nassn);
                            }
                        }
                        if (!kb_key(KB_SCAN_RCONTROL) && !kb_key(54)) {
                            for (i=0; i<nof; i++) {
                                files[i].tag = 0;
                            }
                            files[filetopy+y].tag = 1;
                            makelist(files, nof, filetopy, font, associations,
                             nassn);
                        }
                    }
                    break;
                case 2 :    /* double click - launching */
                    if (files[filetopy+y].filetype == 4 ||
                     files[filetopy+y].filetype == 3) {
                        if (vga_getmousetype() == 4) {
                            mouse_close();
                        }
                        runcommand("open -sw", files[filetopy+y].name, "&",
                         trashdir, font, 0);
                        if (vga_getmousetype() == 4) {
                            vga_setmousesupport(1);
                        }
                    }
                    if (files[filetopy+y].filetype == 6) {
                        j=0;
                        if (strchr(files[filetopy+y].name, '.') != NULL) {
                            for (j=0; j<nassn; j++) {
                                if (!strcmp((char *)strrchr(files[filetopy+y].name,
                                 '.')+1, associations[j].extension)) {
                                    switch (associations[j].run) {
                                    case 0 :    /* run in foreground */
                                        strcpy(source, (char *)quoteit(files[filetopy+y].name)); 
                                        runcommand(associations[j].command,
                                         source, NULL, trashdir, font, 1);
                                        break;
                                    case 1 :    /* run in background */
                                        strcpy(source, (char *)quoteit(files[filetopy+y].name)); 
                                        runcommand(associations[j].command,
                                         source, "&", trashdir, font, 0);
                                        break;
                                    case 2 :    /* switch console */
                                        sprintf(tempstring, "open -sw %s",
                                         associations[j].command);
                                        strcpy(source, (char *)quoteit(files[filetopy+y].name)); 
                                        if (vga_getmousetype() == 4) {
                                            mouse_close();
                                        }
                                        runcommand(tempstring, source, "&",
                                         trashdir, font, 0);
                                        if (vga_getmousetype() == 4) {
                                            vga_setmousesupport(1);
                                        }
                                    }
                                }
                            }
                        }
                        if (!strcmp(files[filetopy+y].name, "makefile") ||
                         !strcmp(files[filetopy+y].name, "Makefile")) {
                            if (vga_getmousetype() == 4) {
                                mouse_close();
                            }
                            runcommand("open -sw make", "&", NULL, trashdir,
                             font, 0);
                            if (vga_getmousetype() == 4) {
                                vga_setmousesupport(1);
                            }
                        }
                        if (!strcmp(files[filetopy+y].name, "Imakefile")) {
                            if (vga_getmousetype() == 4) {
                                mouse_close();
                            }
                            runcommand("xmkmf", NULL, NULL, trashdir, font, 1);
                            runcommand("open -sw make", "&", NULL, trashdir,
                             font, 0);
                            if (vga_getmousetype() == 4) {
                                vga_setmousesupport(1);
                            }
                        }
                        getback = (struct SPTR *)getdirinfo(directories, &nod,
                         files, &nof, treehi, directories[treehi].name, 0);
                        directories = getback->dptr;
                        files = getback->fptr;
                        setwintop(628, 39, 401, 0, 25, filetopy, nof, 0);
                        makelist(files, nof, filetopy, font, associations,
                         nassn);
                    }
                }
                break;
            case 5 :        /* left mouse click in file scrollbar */
                filetopy=setwintop(628, 39, 401, my, 25, filetopy, nof,
                 MOUSE_LEFTBUTTON);
                makelist(files, nof, filetopy, font, associations, nassn);
                break;
            case 6 :        /* left mouse click on application buttons */
                flag=1;
                switch (whichbox(mx)) {
                case 0:
                    flag=0;
                    break;
                case 1:
                    cmnd = (char *)listbox(config.t1, apps, &napps, 7, 258,
                     15, 10, mx, my, font);
                    break;
                case 2:
                    cmnd = (char *)listbox(config.t2, games, &ngames, 97, 258,
                     15, 10, mx, my, font);
                    break;
                case 3:
                    cmnd = (char *)listbox(config.t3, utils, &nutils, 187,
                     258, 15, 10, mx, my, font);
                }
                if (flag && cmnd != NULL) {
                    launch(cmnd, files, nof, font, trashdir);
                    makehotlist(hotlist, apps, napps, games, ngames, utils,
                     nutils, font); 
                }
                break;
            case 7 :    /* left click on icons */
                flag=0;
                swallow(MOUSE_LEFTBUTTON);
                switch (iconselect(mx)) {
                case 1 :    /* printer icon */
                    flag=1;
                    sprintf(command, "open -s %s", config.pic);
                    break;
                case 2 :    /* 3 1/2 drive icon */
                    flag=1;
                    sprintf(command, "open -s %s", config.tic);
                    break;
                case 3 :    /* 5 1/4 drive icon */
                    flag=1;
                    sprintf(command, "open -s %s", config.fic);
                    break;
                case 4 :    /* viewer icon */
                    flag=2;
                    sprintf(command, "open -sw %s", config.vc);
                    break;
                case 5 :    /* editor icon */
                    flag=2;
                    sprintf(command, "open -sw %s", config.ec);
                    break;
                case 6 :    /* compress icon */
                    break;
                case 7 :    /* man icon */
                    flag=0;
                    strcpy(command, "open -sw man");
                    strcpy(dest, " ");
                    textquery("Man Page", "View which man page?", dest, 20,
                     font);
                    strcpy(tempstring, "?");
                    textquery("Section",
                     "Look for man page in which section?", tempstring, 1,
                      font);
                    if (strcmp(tempstring, "?")) {
                        sprintf(source, "%s ", tempstring);
                    }
                    else {
                        strcpy(source, "");
                    }
                    if (strcmp(dest, " ")) {
                        strcat(source, dest);
                        if (vga_getmousetype() == 4) {
                            mouse_close();
                        }
                        runcommand(command, source, "&", trashdir, font, 0);
                        if (vga_getmousetype() == 4) {
                            vga_setmousesupport(1);
                        }
                    }
                    break;
                }
                switch (flag) {
                case 1 :
                    runcommand(command, NULL, "&", trashdir, font, 0);
                    break;
                case 2 :
                    for (i=0; i<nof; i++) {
                        if (files[i].tag) {
                            break;
                        }
                    }
                    if (i < nof) {
                        strcpy(tempstring, files[i].name);
                    }
                    else {
                        strcpy(tempstring, " ");
                    }
                    textquery("Filename", "Enter a file name:", tempstring,
                     30, font);
                    if (strcmp(tempstring, " ")) {
                        strcpy(source, (char *)quoteit(tempstring));
                        if (vga_getmousetype() == 4) {
                            mouse_close();
                        }
                        runcommand(command, source, "&", trashdir, font, 0);
                        if (vga_getmousetype() == 4) {
                            vga_setmousesupport(1);
                        }
                    }
                }
                break;
            case 8 :    /* left mouse click on launcher button */
                swallow(MOUSE_LEFTBUTTON);
                k = whichlaunch(mx);
                if (k) {
                    if (hotlist[k-1].hits >= 0) {
                        launch(hotlist[k-1].command, files, nof, font,
                         trashdir);
                        updatehits(hotlist[k-1].command, apps, napps, games,
                         ngames, utils, nutils);
                        makehotlist(hotlist, apps, napps, games, ngames,
                         utils, nutils, font);
                    }
                }
                break;
            case 9 :    /* left mouse click on exit button */
                exitflag=1;
            }
            mx = mouse_getx()*2;
            my = mouse_gety()*2;
            gl_getbox(mx, my, 16, 16, saveunder);
            gl_putboxmask(mx, my, 16, 16, pointerarrow);
        }
        switch(kb_getkey()) {
        case 0x001b :    /* escape */
            exitflag=1;
            break;
        case 0x0149 :    /* page up key */
            gl_putbox(mx, my, 16, 16, saveunder);
            if (mx < 320) {
                dirtopy=setwintop(308, 39, 401, 51, 25, dirtopy, nod, 0);
                maketree(directories, nod, dirtopy, treehi);
            }
            else {
                filetopy=setwintop(628, 39, 401, 51, 25, filetopy, nof, 0);
                makelist(files, nof, filetopy, font, associations, nassn);
            }
            gl_getbox(mx, my, 16, 16, saveunder);
            if (dmy) {
                gl_putboxmask(mx, my, 15, 14, foldericon);
            }
            else {
                gl_putboxmask(mx, my, 16, 16, pointerarrow);
            }
            break;
        case 0x0151 :    /* page down key */
            gl_putbox(mx, my, 16, 16, saveunder);
            if (mx < 320) {
                dirtopy=setwintop(308, 39, 401, 428, 25, dirtopy, nod, 0);
                maketree(directories, nod, dirtopy, treehi);
            }
            else {
                filetopy=setwintop(628, 39, 401, 428, 25, filetopy, nof, 0);
                makelist(files, nof, filetopy, font, associations, nassn);
            }
            gl_getbox(mx, my, 16, 16, saveunder);
            if (dmy) {
                gl_putboxmask(mx, my, 15, 14, foldericon);
            }
            else {
                gl_putboxmask(mx, my, 16, 16, pointerarrow);
            }
        }
    }
    if (deleteflag) {
    	sprintf(tempstring, "%s/*", trashdir);
        runcommand("rm -rf", tempstring, NULL, trashdir, font, 1);
    }
    writeconfig(associations, nassn, apps, napps, games, ngames, utils,
     nutils, config);
    free(directories);
    free(files);
    free(getback);
    free(font);
    vga_setmode(TEXT);
}
